<?php
/**
 * @package         GeoIp
 * @version         6.1.4
 * 
 * @author          Peter van Westen <info@regularlabs.com>
 * @link            https://regularlabs.com
 * @copyright       Copyright © 2025 Regular Labs All Rights Reserved
 * @license         GNU General Public License version 2 or later
 */

defined('_JEXEC') or die;

use Joomla\CMS\HTML\HTMLHelper as JHtml;
use Joomla\CMS\Language\Text as JText;
use RegularLabs\Library\Input as RL_Input;
use RegularLabs\Library\Language as RL_Language;

RL_Language::load('plg_system_geoip');

require_once __DIR__ . '/updater.php';
$updater = new GeoIPUpdater;

$force = RL_Input::getInt('force');

$result = $updater->update('City', $force);

if ($result->state == 'error')
{
    die('-' . $result->message);
}

if ($result->message)
{
    die('+' . $result->message);
}

$last_date = $updater->getVersion();

if ( ! $last_date)
{
    die();
}

$message = '+' . JText::sprintf('GEO_MESSAGE_UPDATED_TO', JHtml::_('date', $last_date, JText::_('DATE_FORMAT_LC3')));

die($message);
