<?php
/**
 * @package         GeoIp
 * @version         6.1.4
 * 
 * @author          Peter van Westen <info@regularlabs.com>
 * @link            https://regularlabs.com
 * @copyright       Copyright © 2025 Regular Labs All Rights Reserved
 * @license         GNU General Public License version 2 or later
 */

namespace RegularLabs\Plugin\System\GeoIP\Field;

defined('_JEXEC') or die;

use Joomla\CMS\Form\FormField as JFormField;
use Joomla\CMS\HTML\HTMLHelper as JHtml;
use Joomla\CMS\Language\Text as JText;
use RegularLabs\Library\GeoIp\GeoIp as RL_GeoIp;

class GeoVersionField extends JFormField
{
    protected function getInput()
    {
        $file = JPATH_LIBRARIES . '/geoip/GeoLite2-City.date.txt';

        if ( ! RL_GeoIp::hasDatabase())
        {
            return '-';
        }

        if ( ! file_exists($file))
        {
            return '-';
        }

        $last_date = file_get_contents($file);

        if ( ! $last_date)
        {
            return '-';
        }

        return '<span class="label">' . JHtml::_('date', $last_date, JText::_('DATE_FORMAT_LC3')) . '</span>';
    }
}
